webQueueUsersDistrict/Controllers/AdminController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using webQueueUsersDistrict.Models.IdentityUsers;

namespace webQueueUsersDistrict.Controllers
{
    [Authorize(Roles = "Admins")]
    public class AdminController : Controller
    {
        private UserManager<AppUser> userManager;
        private IUserValidator<AppUser> userValidator;
        private IPasswordValidator<AppUser> passwordValidator;
        private IPasswordHasher<AppUser> passwordHasher;

        public AdminController(UserManager<AppUser> userMgr, IUserValidator<AppUser> userValid, IPasswordValidator<AppUser> passValid,
            IPasswordHasher<AppUser> passwordHash)
        {
            userManager = userMgr;
            userValidator = userValid;
            passwordValidator = passValid;
            passwordHasher = passwordHash;
        }
        public ViewResult Index()
        {
            return View(userManager.Users);
        }

        public ViewResult Create() => View();

        [HttpPost]
        public async Task<IActionResult> Create(CreateModel model)
        {
            if (ModelState.IsValid)
            {
                AppUser user = new AppUser
                {
                    UserName = model.Name,
                    Email = model.Email
                };
                IdentityResult result = await userManager.CreateAsync(user, model.Password);
                if (result.Succeeded)
                {
                    return RedirectToAction("Index");
                }
                else
                {
                    foreach (IdentityError error in result.Errors)
                    {
                        if (error != null)
                        {
                            ModelState.AddModelError("", error.Description);
                        }
                      
                    }
                }
            }
            return View(model);
        }

        [HttpPost]
        public async Task<IActionResult> Delete(string id)
        {
            AppUser user = await userManager.FindByIdAsync(id);
            if (user != null)
            {
                IdentityResult result = await userManager.DeleteAsync(user);
                if (result.Succeeded)
                {
                    return RedirectToAction("Index");
                }
                else
                {
                    AddErrorsFromResult(result);
                }
            }
            else
            {
                ModelState.AddModelError("", "User Not Found");
            }
            return View("Index", userManager.Users);
        }
        private void AddErrorsFromResult(IdentityResult result)
        {
            foreach (IdentityError error in result.Errors)
            {
                ModelState.AddModelError("", error.Description);
            }
        }

        public async Task<IActionResult> Edit(string id)
        {
            AppUser user = await userManager.FindByIdAsync(id);
            if (user!=null)
            {
                return View(user);
            }
            else
            {
                return RedirectToAction("Index");
            }
        }


        [HttpPost]
        public async Task<IActionResult> Edit(string id, string email, string password)
        {
            AppUser user = await userManager.FindByIdAsync(id);
            if (user != null)
            {
                user.Email = email;
                IdentityResult validEmail = await userValidator.ValidateAsync(userManager, user);
                if (!validEmail.Succeeded)
                {
                    AddErrorsFromResult(validEmail);
                }
                IdentityResult validPass = null;
                if (!string.IsNullOrEmpty(password))
                {
                    validPass = await passwordValidator.ValidateAsync(userManager, user, password);
                    if (validPass.Succeeded)
                    {
                        user.PasswordHash = passwordHasher.HashPassword(user, password);
                    }
                    else
                    {
                        AddErrorsFromResult(validPass);
                    }
                }
                if ((validEmail.Succeeded && validPass == null) ||
                    (validEmail.Succeeded && password != string.Empty && validPass.Succeeded))
                {
                    IdentityResult result = await userManager.UpdateAsync(user);
                    if (result.Succeeded)
                    {
                        return RedirectToAction("Index");
                    }
                    else
                    {
                        AddErrorsFromResult(result);
                    }
                }
            }
            else
            {
                ModelState.AddModelError("", "User Not Found");
            }
            return View(user);
        }
    }
}

webQueueUsersDistrict/Views/Shared/PageOptions.cshtml
<div class="container-fluid  mt-md-2">
    <div class="row  m-1">

        <div class="col-1 p-0">
            <label class="col-form-label">Поиск по:</label>
        </div>
        <div class="col-3 ">
            <select form="pageform" name="options.searchpropertyname"
                    class="form-control">
                @foreach (var s in ViewBag.searches as Dictionary<string, string>)
                {
                    <option value="@s.Key"
                            selected="@(Model.Options.SearchPropertyName == s.Key)">
                        @(s.Value)
                    </option>
                }
            </select>
        </div>
        <div class="col">
            <input form="pageform" class="form-control"
                   name="options.searchterm"
                   value="@Model.Options.SearchTerm" />
        </div>
        <div class="col-1  text-left">
            <button form="pageform" class="btn btn-secondary" type="submit">
                Искать
            </button>
        </div>
        <div class="col"></div>
    </div>
    <div class="row  m-1">

        <div class="col-1 p-0">
            <label class="col-form-label">Сортировка по:</label>
        </div>
        <div class="col-3">
            <select form="pageform" name="options.OrderPropertyName"
                    class="form-control">
                @foreach (var s in ViewBag.sorts as Dictionary<string, string>)
                {
                    <option value="@s.Key"
                            selected="@(Model.Options.OrderPropertyName == s.Key)">
                        @(s.Value)
                    </option>
                }
            </select>
        </div>


        <div class="col">
            <div class="col form-check form-check-inline">
                <div class="custom-control custom-switch">
                    <input form="pageform" type="checkbox" name="Options.DescendingOrder"
                           id="Options.DescendingOrder"
                           class="custom-control-input" value="true"
                           checked="@Model.Options.DescendingOrder" />
                    <label for="Options.DescendingOrder" class="custom-control-label">По убыванию</label>
                </div>
            </div>
        </div>

            <div class="col-1  text-right">
                <button form="pageform" class="btn btn-secondary" type="submit">
                    Сортировать
                </button>
            </div>
            <div class="col"></div>
        </div>
    </div>

webQueueUsersDistrict/Views/Shared/Pages.cshtml
<form id="pageform" method="post" class="form-inline d-inline-block">

    <button name="options.currentPage" value="@(Model.CurrentPage -1)"
            class="btn btn-outline-primary @(!Model.HasPreviousPage ? "disabled" : "")" @(Model.CurrentPage != 1 ? "" : "disabled")
            type="submit">
        Назад
    </button>


    @for (int i = 1; i <= 3 && i <= Model.TotalPages; i++)
    {
        <button name="options.currentPage" value="@i" type="submit"
                class="btn btn-outline-primary @(Model.CurrentPage == i ? "active" : "")">
            @i
        </button>
    }
    @if (Model.CurrentPage > 3 && Model.TotalPages - Model.CurrentPage >= 3)
    {
        @:...
        <button class="btn btn-outline-primary active">@Model.CurrentPage</button>
    }
    @if (Model.TotalPages > 3)
    {
        @:...
        @for (int i = Math.Max(4, Model.TotalPages - 2);
                 i <= Model.TotalPages; i++)
        {
            <button name="options.currentPage" value="@i" type="submit"
                    class="btn btn-outline-primary
                   @(Model.CurrentPage == i ? "active" : "")">
                @i
            </button>
        }
    }

    <button name="options.currentPage" value="@(Model.CurrentPage + 1)" type="submit"
            class="btn btn-outline-primary @(!Model.HasNextPage? "disabled" : "")" @(Model.CurrentPage != Model.TotalPages ? "" : "disabled")>
        Вперед
    </button>




    <select name="options.pageSize" class="form-control ml-1 mr-1">
        @foreach (int val in new int[] { 10, 25, 50, 100 })
        {
            <option value="@val" selected="@(Model.PageSize == val)">@val</option>
        }
    </select>
    <input type="hidden" name="options.currentPage" value="1" />
    <button type="submit" class="btn btn-primary">Изменить количество выводимых записей на странице</button>


</form>

webQueueUsersDistrict/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - webQueueUsersDistrict</title>
    <link rel="stylesheet" asp-href-include="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" asp-href-include="~/css/site.css" />
    <script asp-src-include="~/lib/jquery/dist/jquery.min.js"></script>
    <script asp-src-include="~/lib/jquery-validation/dist/jquery.validate.js"></script>
    <script asp-src-include="~/lib/jquery-validation-unobtrusive/dist/jquery.validate.unobtrusive.js"></script>
    <script asp-src-include="~/js/editUser.js"></script>

</head>
<body>
    <header>

        <nav class="navbar navbar-dark bg-dark">
            <div class="btn-group col-md-3">
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
            </div>
            <div class="btn-group col-md-auto">
                <form asp-action="Edit" method="post" class="form-inline my-2 my-lg-0">
                    @if (User.Identity.IsAuthenticated)
                    {
                        <button type="submit" class="btn btn-outline-light my-2 my-sm-0" asp-area="" asp-controller="Account" asp-action="Logout">Выход</button>
                    }

                </form>
            </div>
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <div class="container-fluid">
                    <ul class="nav navbar-nav">
                        <li class="nav-item ">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>

                        <li class="nav-item ">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="TestCodingValue">Test CodingLogin</a>
                        </li>

                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="" asp-controller="Home" asp-action="Privacy">Провека требований - claims</a>
                        </li>

                        <li class="nav-item dropdown text-white ">
                            <a class="nav-link dropdown-toggle  text-white" href="#" id="navbarDropdownUsersWebVersion" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Пользователи Веб версии
                            </a>
                            <div class="dropdown-menu " aria-labelledby="navbarDropdownUsersWebVersion">
                                <a class="dropdown-item text-white " asp-area="" asp-controller="Admin" asp-action="Edit">Добавление пользователей</a>
                                <div></div>
                                <a class="dropdown-item text-white" asp-area="" asp-controller="Roleadmin" asp-action="Index">Настройка ролей</a>
                            </div>
                        </li>

                        <li class="nav-item dropdown text-white">
                            <a class="nav-link dropdown-toggle text-white" href="#" id="navbarDropdownUsersDesktopVersion" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Пользователи настольной версии АРМ ИЖО
                            </a>
                            <div class="dropdown-menu" aria-labelledby="navbarDropdownUsersDesktopVersion">
                                <a class="dropdown-item text-white" asp-area="" asp-controller="Home" asp-action="CreateUser">Создание нового пользователя</a>
                                <div></div>
                                <a class="dropdown-item text-white" asp-area="" asp-controller="Home" asp-action="Search">Поиск пользователей</a>
                            </div>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="col">
        @RenderBody()
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2019 - Hello world - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>